#ifndef __HELLOWORLD_SCENE_H__
#define __HELLOWORLD_SCENE_H__

#include "cocos2d.h"
#include "cocos-ext.h"

/// 本人只是方便才直接使用空间名称
USING_NS_CC;
USING_NS_CC_EXT;

class HelloWorld : public cocos2d::CCLayer, public cocos2d::extension::CCTableViewDataSource, public cocos2d::extension::CCTableViewDelegate
{
public:
    HelloWorld();
    virtual ~HelloWorld();
    // Here's a difference. Method 'init' in cocos2d-x returns bool, instead of returning 'id' in cocos2d-iphone
    virtual bool init();  

    // there's no 'id' in cpp, so we recommend returning the class instance pointer
    static cocos2d::CCScene* scene();
    
    // a selector callback
    void menuCloseCallback(CCObject* pSender);
    
    // implement the "static node()" method manually
    CREATE_FUNC(HelloWorld);
    /**
     *	@brief	在场景中载入table
     *
     *	@Modified by poche at 2014-05-26 21:59:32
    **/
    void addTableView();
    /**
     *	@brief	初始化表格里的数据
     *
     *	@Modified by poche at 2014-05-26 22:17:16
    **/
    void initData();
    /**
     *	@brief	删除cell
     *
     *	@Modified by poche at 2014-05-26 22:39:14
    **/
    void deleteCell(CCObject* pSender);
    /**
     *	@brief	添加cell
     *
     *	@Modified by poche at 2014-05-26 22:39:03
    **/
    void addCell(CCObject* pSender);
    
    /// table所需要的方法
    virtual CCSize cellSizeForTable(CCTableView *table);
    virtual CCTableViewCell* tableCellAtIndex(CCTableView *table, unsigned int idx);
    virtual unsigned int numberOfCellsInTableView(CCTableView *table);
    virtual void tableCellTouched(CCTableView* table, CCTableViewCell* cell);
    virtual void scrollViewDidScroll(CCScrollView* view);
    virtual void scrollViewDidZoom(CCScrollView* view);
    
    CC_SYNTHESIZE_RETAIN(cocos2d::extension::CCTableView*, m_table, _table);    /// 保存已经生成的表格
    CC_SYNTHESIZE_RETAIN(cocos2d::CCArray*, m_data, _data); /// 表格的数据

};

#endif // __HELLOWORLD_SCENE_H__
