//
//  WdTableView.cpp
//  tttt
//
//  Created by Windy on 12/27/13.
//
//

#include "WdTableView.h"

USING_NS_CC;
USING_NS_CC_EXT;


/// 初始化部分成员属性
WdTableView::WdTableView()
: _displayedOpacity(255)
, _realOpacity(255)
, _displayedColor(ccWHITE)
, _realColor(ccWHITE)
, _cascadeColorEnabled(false)
, _cascadeOpacityEnabled(false)
{
}
WdTableView::~WdTableView(){
    
}

WdTableView* WdTableView::create(CCTableViewDataSource* dataSource, CCSize size)
{
    return WdTableView::create(dataSource, size, NULL);
}

WdTableView* WdTableView::create(CCTableViewDataSource* dataSource, CCSize size, CCNode *container)
{
    WdTableView *table = new WdTableView();
    /// 以下方法都是利用父类来作出初始化的
    table->initWithViewSize(size, container);
    table->autorelease();
    table->setDataSource(dataSource);
    table->_updateCellPositions();
    table->_updateContentSize();
    
    return table;
}
void WdTableView::insertCellAtIndex(unsigned  int idx, float insertDelayTime)
{
    if (idx == CC_INVALID_INDEX)
    {
        return;
    }
    
    unsigned int uCountOfItems = m_pDataSource->numberOfCellsInTableView(this);
    if (0 == uCountOfItems || idx > uCountOfItems-1)
    {
        return;
    }
    
    CCTableViewCell* cell = NULL;
    int newIdx = 0;
    
    cell = (CCTableViewCell*)m_pCellsUsed->objectWithObjectID(idx);
    m_pIndices->clear();
    if (cell)
    {
        newIdx = m_pCellsUsed->indexOfSortedObject(cell);
        
        for (int i = 0; i < (int)newIdx; ++i) {
            cell = (CCTableViewCell*)m_pCellsUsed->objectAtIndex(i);
            m_pIndices->insert(cell->getIdx());
        }
        
        for (unsigned int i=newIdx; i<m_pCellsUsed->count(); i++)
        {
            cell = (CCTableViewCell*)m_pCellsUsed->objectAtIndex(i);
            int ni = cell->getIdx()+1;
            this->_setIndexForCell(ni, cell, true);
            m_pIndices->insert(ni);
        }
    }
    /// 是否要作推迟插入cell
    if (insertDelayTime > 0) {
        m_indexToInsert = idx;
        /// 动画，如果有需要。，可以自己抽出来改
        CCDelayTime* delay = CCDelayTime::create(0.2f);
        CCCallFunc* call = CCCallFunc::create(this, callfunc_selector(WdTableView::delayInsertCell));
        CCSequence* seq = CCSequence::createWithTwoActions(delay, call);
        this->runAction(seq);
    } else {
        cell = m_pDataSource->tableCellAtIndex(this, idx);
        this->_setIndexForCell(idx, cell, false);
        this->_addCellIfNecessary(cell);
        
        this->_updateCellPositions();
        this->_updateContentSize();
    }
}

void WdTableView::delayInsertCell()
{
    /// 重新更新一下整个table
    CCTableViewCell* cell = m_pDataSource->tableCellAtIndex(this, m_indexToInsert);
    this->_setIndexForCell(m_indexToInsert, cell, false);
    this->_addCellIfNecessary(cell);
    
    this->_updateCellPositions();
    this->_updateContentSize();
}

void WdTableView::removeCellAtIndex(unsigned int idx)
{
    if (idx == CC_INVALID_INDEX)
    {
        return;
    }
    
    unsigned int uCountOfItems = m_pDataSource->numberOfCellsInTableView(static_cast<CCTableView*>(this));
    if (0 == uCountOfItems || idx > uCountOfItems-1)
    {
        return;
    }
    
    unsigned int newIdx = 0;
    
    CCTableViewCell* cell = this->cellAtIndex(idx);
    if (!cell)
    {
        return;
    }
    
    newIdx = m_pCellsUsed->indexOfSortedObject(cell);
    
    //remove first
    this->_moveCellOutOfSight(cell);
    
    
    this->_updateCellPositions();
    //    [m_pIndices shiftIndexesStartingAtIndex:idx+1 by:-1];
    
    // 重新修改indices的值
    m_pIndices->clear();
    for (int i = 0; i < (int)newIdx; ++i) {
        cell = (CCTableViewCell*)m_pCellsUsed->objectAtIndex(i);
        m_pIndices->insert(cell->getIdx());
    }
    
    for (int i=(int)m_pCellsUsed->count()-1; i >= (int)newIdx; --i)
    {
        cell = (CCTableViewCell*)m_pCellsUsed->objectAtIndex(i);
        int ni = cell->getIdx()-1;
        this->_setIndexForCell(ni, cell, true);
        m_pIndices->insert(ni);
    }
    
    // 补充最后一个元素
    if (m_pCellsUsed->count() > 0) {
        cell = (CCTableViewCell*)m_pCellsUsed->objectAtIndex(m_pCellsUsed->count() - 1);
        int index = cell->getIdx() + 1;
        if (index < (int)m_pDataSource->numberOfCellsInTableView(this)) {
            // 超出显示范围，更新
            this->updateCellAtIndex(index);
            
            // 更新完毕，重新取最后一个cell
            cell = (CCTableViewCell*)m_pCellsUsed->objectAtIndex(m_pCellsUsed->count() - 1);
            CCPoint dst = cell->getPosition();
            cell->setPositionX(dst.x + m_vCellsPositions[index] - m_vCellsPositions[index - 1]);
            CCMoveTo* moveTo = CCMoveTo::create(0.2f, dst);
            cell->runAction(moveTo);
        }
    }
}

void WdTableView::_setIndexForCell(unsigned int index, CCTableViewCell *cell, bool animate)
{
    if (!cell) {
        return;
    }
    cell->setAnchorPoint(ccp(0.0f, 0.0f));
    CCPoint pt = this->_offsetFromIndex(index);
    if (animate) {
        CCMoveTo* moveTo = CCMoveTo::create(0.2f, pt);
        cell->runAction(moveTo);
    } else {
        cell->setPosition(pt);
    }
    
    cell->setIdx(index);
}

int WdTableView::indexFromPoint(int x, int y)
{
    CCPoint offset = this->convertToNodeSpace(ccp(x, y));
    CCPoint of2 = getContentOffset();
    offset.x -= of2.x;
    offset.y -= of2.y;
    int index =  _indexFromOffset(offset);
    CCPoint roffset = _offsetFromIndex(index);
    CCSize size = m_pDataSource->cellSizeForTable(this);
    if (offset.x - roffset.x >= size.width / 2) {
        ++index;
    }
    
    if (index < 0) {
        index = 0;
    }
    
    int amount = m_pDataSource->numberOfCellsInTableView(this);
    if (index > amount) {
        index = amount;
    }
    return index;
}

CCPoint WdTableView::pointFromIndex(int index)
{
    CCPoint offset = __offsetFromIndex(index);
    CCPoint of2 = getContentOffset();
    offset.x += of2.x;
    offset.y += of2.y;
    
    CCPoint pt = convertToWorldSpace(offset);
    pt = getParent()->convertToNodeSpace(pt);
    return pt;
}

#pragma mark -
#pragma mark CCRGBAProtocol
/**
 * Changes the color with R,G,B bytes
 *
 * @param color Example: ccc3(255,100,0) means R=255, G=100, B=0
 */
void WdTableView::setColor(const ccColor3B& color){
    _displayedColor = _realColor = color;
    
    if (_cascadeColorEnabled)
    {
        ccColor3B parentColor = ccWHITE;
        CCRGBAProtocol *parent = dynamic_cast<CCRGBAProtocol*>(m_pParent);
        if (parent && parent->isCascadeColorEnabled())
        {
            parentColor = parent->getDisplayedColor();
        }
        
        updateDisplayedColor(parentColor);
    }
}

/**
 * Returns color that is currently used.
 *
 * @return The ccColor3B contains R,G,B bytes.
 */
const ccColor3B& WdTableView::getColor(void){
    return _realColor;
}

/**
 * Returns the displayed color.
 *
 * @return The ccColor3B contains R,G,B bytes.
 */
const ccColor3B& WdTableView::getDisplayedColor(void){
    return _displayedColor;
}

/**
 * Returns the displayed opacity.
 *
 * @return  The opacity of sprite, from 0 ~ 255
 */
GLubyte WdTableView::getDisplayedOpacity(void){
    return _displayedOpacity;
}
/**
 * Returns the opacity.
 *
 * The opacity which indicates how transparent or opaque this node is.
 * 0 indicates fully transparent and 255 is fully opaque.
 *
 * @return  The opacity of sprite, from 0 ~ 255
 */
GLubyte WdTableView::getOpacity(void){
    return _realOpacity;
}

/**
 * Changes the opacity.
 *
 * @param   value   Goes from 0 to 255, where 255 means fully opaque and 0 means fully transparent.
 */
void WdTableView::setOpacity(GLubyte opacity){
    _displayedOpacity = _realOpacity = opacity;
    
    if (_cascadeOpacityEnabled)
    {
        GLubyte parentOpacity = 255;
        CCRGBAProtocol* pParent = dynamic_cast<CCRGBAProtocol*>(m_pParent);
        if (pParent && pParent->isCascadeOpacityEnabled())
        {
            parentOpacity = pParent->getDisplayedOpacity();
        }
        this->updateDisplayedOpacity(parentOpacity);
    }
    if (opacity == 0) {
        setVisible(false);
    }
    else
        setVisible(true);
}

// optional

/**
 *  whether or not color should be propagated to its children.
 */
bool WdTableView::isCascadeColorEnabled(void){
    return _cascadeColorEnabled;
}
void WdTableView::setCascadeColorEnabled(bool cascadeColorEnabled){
    _cascadeColorEnabled = cascadeColorEnabled;
}

/**
 *  recursive method that updates display color
 */
void WdTableView::updateDisplayedColor(const ccColor3B& parentColor){
    
    _displayedColor.r = _realColor.r * parentColor.r/255.0;
    _displayedColor.g = _realColor.g * parentColor.g/255.0;
    _displayedColor.b = _realColor.b * parentColor.b/255.0;
    
    if (_cascadeColorEnabled)
    {
        CCObject *obj = NULL;
        CCARRAY_FOREACH(m_pChildren, obj)
        {
            CCRGBAProtocol *item = dynamic_cast<CCRGBAProtocol*>(obj);
            if (item)
            {
                item->updateDisplayedColor(_displayedColor);
            }
        }
    }
}

/**
 *  whether or not opacity should be propagated to its children.
 */
bool WdTableView::isCascadeOpacityEnabled(void){
    return _cascadeOpacityEnabled;
}
void WdTableView::setCascadeOpacityEnabled(bool cascadeOpacityEnabled){
    _cascadeOpacityEnabled = cascadeOpacityEnabled;
}

/**
 *  recursive method that updates the displayed opacity.
 */
void WdTableView::updateDisplayedOpacity(GLubyte parentOpacity){
    _displayedOpacity = _realOpacity * parentOpacity/255.0;
    
    if (_cascadeOpacityEnabled)
    {
        CCObject* _s_pcell = NULL;
        CCARRAY_FOREACH(m_pCellsUsed, _s_pcell)
        {
            CCObject* pObj = NULL;
            CCTableViewCell* cell = dynamic_cast<CCTableViewCell*>(_s_pcell);
            
            if (cell) {
                CCARRAY_FOREACH(cell->getChildren(), pObj)
                {
                    CCRGBAProtocol* item = dynamic_cast<CCRGBAProtocol*>(pObj);
                    if (item)
                    {
                        item->setOpacity(_displayedOpacity);
                    }
                }
            }
        }
    }
}

bool WdTableView::isOpacityModifyRGB(void){
    return false;
}
void WdTableView::setOpacityModifyRGB(bool bValue){
    CC_UNUSED_PARAM(bValue);
}